unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type tMas = array[1..50,1..50] of integer;
type tVirkne = array[1..1000] of integer;

var
  Form1: TForm1;
  vFirst, vMax, vCol, vRow, t, vTemp, vTemp2, vZero: integer;
  mas, aTemp: tMas;
  vSlanaCelaGarums,vSlanaMinSkaitlis: integer;
  vSlanaVirkne, vSlanaVirknesSkaitli: tVirkne;
  a, count: integer;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
button1Click(nil);
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
close
end;


procedure myError(vStr: string);
begin
     showmessage( vStr );
     abort;
end;


procedure ieladeMasiva;
var f: text;n:integer;
begin
  try
  assign(f,'matrica.txt');
  except
    MyError('nevar atvert failu "matrica.txt" !!!');
  end;
  reset(f);
  readln(f,vMax);
  for vRow := 1 to vMax do begin
    for vCol := 1 to vMax do begin
        read(f,n);
        if n<0 then MyError('Nevar nolast no faila '+IntToStr(n)+' matricu !');
        mas[vRow,vCol] := n;

    end;{for Rin}
  end;{for Kol}
  close(f);
end;

procedure copyMas(var aSource, aDest: tMas);
begin
   for vRow:=1 to vMax do
       for vCol := 1 to vMax do
           aDest[vRow,vCol] := aSource[vRow,vCol];
end; {copyMas}






procedure ZimeShemu(masivs: tMas);
begin
with Form1 do begin
  Memo1.Lines.Add('');
  Memo1.Lines.Add('     SHMA');
  for vRow := 1 to vMax do begin
  		for vCol := 1 to vMax do begin
  			Memo1.Text := Memo1.Text + ' ' + IntToStr(masivs[vRow, vCol]);
   	end;
  Memo1.Lines.Add('');
  end;

end;{with}
end;





function IrCels(tempMas: tMas; var source, dest: integer): boolean;
var t: integer;
begin
  result := False;
  if source = dest then begin Result := True; exit; end;
     // Apskata vai teko virsotne incid ar prjm (prjs ar prjm - rekursvi)
     for t:=1 to vMax do begin
        if tempMas[source,t] > 0 then begin
           tempMas[source,t] := 0;
           result := False;
           result := IrCels(tempMas,t,dest);
           if result then exit;
        end;
        // Nav
     end; {for}
     result := False;
end; {IrCels}


function irAtbilde: boolean;
begin
   //copyMas(mas,aTemp);
   vTemp := 1;
   vTemp2 := vMax;
   irAtbilde := IrCels(mas,vTemp,vTemp2);
end;



function virkneSatur(pVirkne: tVirkne; pVirknesGarums, pMeklVirsotne: integer): boolean;
var t: integer;
begin
  result := False;
  if pVirknesGarums <1 then exit;
  // Meklejam vis virkn ms interesjoi virsotni
  for t:=1 to pVirknesGarums do
      if pVirkne[t] = pMeklVirsotne then begin
         result := True;
         exit;
      end;{if}

end;



function iegustSlani(var masivs: tMas;
                     var pSource,
                     pDest: integer;
                     pVirkne,
                     pBultuSkaitli: tVirkne;
                     pVirknesGarums: integer;
                     var pMinVirknesGar: integer;
                     var pMinVirkne,pMinBultuSkaitli: tVirkne;
                     var pSlanaMinSkaitlis: integer;
                     pCelaMinSkaitlis: integer
                     ): boolean;
var vRes: boolean;
    t:integer;
begin
  vRes := False;
  //inc(pVirknesGarums);

  // is ce neder, jo ir garks nek pagaidm atrastais
  //if pVirknesGarums > pMinVirknesGar then begin
  //   dec(pVirknesGarums);
  //end;
  if pSource = pDest then begin
     // Tikko atrastais ce ir skais un ta minimlais skaitlis
     // ir lielkais no pagaidm atrastajiem ceiem
  	  if ((pVirknesGarums < pMinVirknesGar)
         and (pCelaMinSkaitlis > pSlanaMinSkaitlis)
         and (pCelaMinSkaitlis > 0))
         or ((pMinVirknesGar = 0)
            and (pCelaMinSkaitlis > 0))
          then begin
                 //dec(pVirknesGarums);
                 pMinVirknesGar := pVirknesGarums;
                 pVirkne[pVirknesGarums+1] := pSource;
                 pMinVirkne := pVirkne;
                 pMinBultuSkaitli := pBultuSkaitli;
                 pSlanaMinSkaitlis := pCelaMinSkaitlis;
     end;
     result := true;
     exit;
  end;
     // Izskrienam cauri visiem iespjamiem grafa ceiem
     for t:=1 to vMax do begin
        if masivs[pSource,t] > 0 then begin
           // Pievienojam ceam jaunu virsotni
           inc(pVirknesGarums);
           pVirkne[pVirknesGarums] := pSource;
           pBultuSkaitli[pVirknesGarums] := Masivs[pSource,t];

           // Mekljam minimalo ceam skaitli
           if ((mas[pSource,t] < pCelaMinSkaitlis)
              or (pCelaMinSkaitlis = 0)) then
					if (mas[pSource,t] > 0) then
                 pCelaMinSkaitlis := mas[pSource,t];

           masivs[pSource,t] := 0;
           // Ja incidjo virsotne nav apskatta,
           // tad brienam savienotaj virsotn
           if not VirkneSatur(pVirkne,pVirknesGarums,t)
           then
           vRes := IegustSlani(masivs,t,pDest,pVirkne,pBultuSkaitli,
                               pVirknesGarums,pMinVirknesGar,pMinVirkne,
                               pMinBultuSkaitli,pSlanaMinSkaitlis,pCelaMinSkaitlis);
           dec(pVirknesGarums);
           //if vRes then begin
           //   end;{if}
           //end;
        end;
        // Nav
     end; {for}
     result := vRes;

end; {IrCels}




procedure drukaSlani;
begin
 // Druk slni
 with form1.memo1 do begin
  Lines.Add('');
  Lines.Add('    SLNIS  (minim.sk.=' + IntToStr(vSlanaMinSkaitlis)+')');
  for t:=1 to vSlanaCelaGarums do
    // Druk formt virsotne(vertiba)=>
    Text := Text + ' ' + IntToStr(vSlanaVirkne[t]) + '(' + IntToStr(vSlanaVirknesSkaitli[t]) + ')->';

  if vSlanaCelaGarums <> 0 then Text := Text + IntToStr(vMax);
  Lines.Add('');
 end;{with}
end;

procedure RekinaSlani;
var a1,a2: tVirkne;
    t: integer;
begin
 vSlanaCelaGarums:=0;
 //vSlanaVirkne:=0;
 //vSlanaVirknesSkaitli:=0;
 vSlanaMinSkaitlis:=0;

 CopyMas(mas,aTemp);
 iegustSlani(aTemp,vFirst,vMax,a1,a2,vZero,vSlanaCelaGarums,vSlanaVirkne,vSlanaVirknesSkaitli,vSlanaMinSkaitlis,vZero);
end;




procedure RekinaShemu(var mas: tMas);
//var a: integer;
begin
a:=1;
for a := 1 to vSlanaCelaGarums do begin
    // ierakstam tekoaj sla virsotn izejoai bultai starpibu, starp esoo virsotnes skaitli
    // un minimlo sla cea skaitli
    mas[vSlanaVirkne[a],vSlanaVirkne[a+1]] := mas[vSlanaVirkne[a],vSlanaVirkne[a+1]] - vSlanaMinSkaitlis;
    // tekos virsotns ieejoaj bult ierakstam la cea minimlo skaitli
    mas[vSlanaVirkne[a+1],vSlanaVirkne[a]] := mas[vSlanaVirkne[a+1],vSlanaVirkne[a]]+  vSlanaMinSkaitlis;
end;{for}

end;








//                SAKUMS
procedure TForm1.Button1Click(Sender: TObject);
begin
   vFirst := 1;
   Memo1.Text := '';

	IeladeMasiva;
   ZimeShemu(mas);
   RekinaSlani;
   DrukaSlani;

   // Veic shmu itercijas
	while IrAtbilde do begin
       // Shma
       RekinaShemu(mas);
       ZimeShemu(mas);
       // Slnis
   	 RekinaSlani;
       if irAtbilde then
          DrukaSlani
       else
       if vSlanaCelaGarums = 0 then begin memo1.Lines.Add('Nevar atrast nevienu slni'); exit; end;

       inc(count);
       if count > 300 then begin showmessage('Ieciklojs progze vai ar tiek iegti vairk nek 300 jaunas shmas');exit;end;

	end;{while}
end;




end.
